? doc/src/sgml/ref/create_domain.sgml
? doc/src/sgml/ref/drop_domain.sgml
Index: doc/src/sgml/catalogs.sgml
===================================================================
RCS file: /projects/cvsroot/pgsql/doc/src/sgml/catalogs.sgml,v
retrieving revision 2.30
diff -c -r2.30 catalogs.sgml
*** doc/src/sgml/catalogs.sgml	2002/02/18 23:10:59	2.30
--- doc/src/sgml/catalogs.sgml	2002/02/26 02:56:15
***************
*** 2497,2502 ****
--- 2497,2549 ----
       </row>
  
       <row>
+       <entry>typbasetype</entry>
+       <entry><type>oid</type></entry>
+       <entry></entry>
+       <entry><para>
+        <structfield>typbasetype</structfield> is the type that this one is based
+        off of.  Normally references the domains parent type, and is 0 otherwise.
+       </para></entry>
+      </row>
+ 
+ 	 <row>
+ 	  <entry>typnotnull</entry>
+ 	  <entry><type>boolean</type></entry>
+ 	  <entry></entry>
+ 	  <entry><para>
+ 	   <structfield>typnotnull</structfield> represents a NOT NULL
+ 	   constraint on a type.  Normally used only for domains.
+ 	  </para></entry>
+ 	 </row>
+ 
+      <row>
+       <entry>typmod</entry>
+       <entry><type>integer</type></entry>
+       <entry></entry>
+       <entry><para>
+        <structfield>typmod</structfield> records type-specific data
+        supplied at table creation time (for example, the maximum
+        length of a <type>varchar</type> column).  It is passed to
+        type-specific input and output functions as the third
+        argument. The value will generally be -1 for types that do not
+        need typmod.  This data is copied to
+        <structfield>pg_attribute.atttypmod</structfield> on creation
+        of a table using a domain as it's field type.
+        </para></entry>
+      </row>
+ 
+      <row>
+       <entry>typdefaultbin</entry>
+       <entry><type>text</type></entry>
+       <entry></entry>
+       <entry><para>
+        <structfield>typdefaultbin</structfield> is NULL for types without a
+        default value.  If it's not NULL, it contains the internal string
+        representation of the default expression node.
+       </para></entry>
+      </row>
+ 
+      <row>
        <entry>typdefault</entry>
        <entry><type>text</type></entry>
        <entry></entry>
Index: doc/src/sgml/reference.sgml
===================================================================
RCS file: /projects/cvsroot/pgsql/doc/src/sgml/reference.sgml,v
retrieving revision 1.20
diff -c -r1.20 reference.sgml
*** doc/src/sgml/reference.sgml	2002/01/15 05:05:49	1.20
--- doc/src/sgml/reference.sgml	2002/02/26 02:56:15
***************
*** 60,65 ****
--- 60,66 ----
     &createAggregate;
     &createConstraint;
     &createDatabase;
+    &createDomain;
     &createFunction;
     &createGroup;
     &createIndex;
***************
*** 77,82 ****
--- 78,84 ----
     &delete;
     &dropAggregate;
     &dropDatabase;
+    &dropDomain;
     &dropFunction;
     &dropGroup;
     &dropIndex;
***************
*** 114,120 ****
     &unlisten;
     &update;
     &vacuum;
!   
   </reference>
  
  <!--
--- 116,122 ----
     &unlisten;
     &update;
     &vacuum;
! 
   </reference>
  
  <!--
Index: doc/src/sgml/ref/allfiles.sgml
===================================================================
RCS file: /projects/cvsroot/pgsql/doc/src/sgml/ref/allfiles.sgml,v
retrieving revision 1.32
diff -c -r1.32 allfiles.sgml
*** doc/src/sgml/ref/allfiles.sgml	2002/01/15 05:05:49	1.32
--- doc/src/sgml/ref/allfiles.sgml	2002/02/26 02:56:15
***************
*** 51,56 ****
--- 51,57 ----
  <!entity createAggregate    system "create_aggregate.sgml">
  <!entity createConstraint   system "create_constraint.sgml">
  <!entity createDatabase     system "create_database.sgml">
+ <!entity createDomain       system "create_domain.sgml">
  <!entity createFunction     system "create_function.sgml">
  <!entity createGroup        system "create_group.sgml">
  <!entity createIndex        system "create_index.sgml">
***************
*** 68,73 ****
--- 69,75 ----
  <!entity delete             system "delete.sgml">
  <!entity dropAggregate      system "drop_aggregate.sgml">
  <!entity dropDatabase       system "drop_database.sgml">
+ <!entity dropDomain         system "drop_domain.sgml">
  <!entity dropFunction       system "drop_function.sgml">
  <!entity dropGroup          system "drop_group.sgml">
  <!entity dropIndex          system "drop_index.sgml">
Index: doc/src/sgml/ref/comment.sgml
===================================================================
RCS file: /projects/cvsroot/pgsql/doc/src/sgml/ref/comment.sgml,v
retrieving revision 1.12
diff -c -r1.12 comment.sgml
*** doc/src/sgml/ref/comment.sgml	2001/12/27 21:36:57	1.12
--- doc/src/sgml/ref/comment.sgml	2002/02/26 02:56:17
***************
*** 25,31 ****
    <synopsis>
  COMMENT ON
  [
!   [ DATABASE | INDEX | RULE | SEQUENCE | TABLE | TYPE | VIEW ] <replaceable class="PARAMETER">object_name</replaceable> |
    COLUMN <replaceable class="PARAMETER">table_name</replaceable>.<replaceable class="PARAMETER">column_name</replaceable> |
    AGGREGATE <replaceable class="PARAMETER">agg_name</replaceable> (<replaceable class="PARAMETER">agg_type</replaceable>) |
    FUNCTION <replaceable class="PARAMETER">func_name</replaceable> (<replaceable class="PARAMETER">arg1</replaceable>, <replaceable class="PARAMETER">arg2</replaceable>, ...) |
--- 25,31 ----
    <synopsis>
  COMMENT ON
  [
!   [ DATABASE | DOMAIN | INDEX | RULE | SEQUENCE | TABLE | TYPE | VIEW ] <replaceable class="PARAMETER">object_name</replaceable> |
    COLUMN <replaceable class="PARAMETER">table_name</replaceable>.<replaceable class="PARAMETER">column_name</replaceable> |
    AGGREGATE <replaceable class="PARAMETER">agg_name</replaceable> (<replaceable class="PARAMETER">agg_type</replaceable>) |
    FUNCTION <replaceable class="PARAMETER">func_name</replaceable> (<replaceable class="PARAMETER">arg1</replaceable>, <replaceable class="PARAMETER">arg2</replaceable>, ...) |
***************
*** 33,39 ****
    TRIGGER <replaceable class="PARAMETER">trigger_name</replaceable> ON <replaceable class="PARAMETER">table_name</replaceable>
  ] IS <replaceable class="PARAMETER">'text'</replaceable>
    </synopsis>
!   
    <refsect2 id="R2-SQL-COMMENT-1">
     <refsect2info>
      <date>1999-10-25</date>
--- 33,39 ----
    TRIGGER <replaceable class="PARAMETER">trigger_name</replaceable> ON <replaceable class="PARAMETER">table_name</replaceable>
  ] IS <replaceable class="PARAMETER">'text'</replaceable>
    </synopsis>
! 
    <refsect2 id="R2-SQL-COMMENT-1">
     <refsect2info>
      <date>1999-10-25</date>
***************
*** 64,70 ****
      </variablelist>
     </para>
    </refsect2>
!   
    <refsect2 id="R2-SQL-COMMENT-2">
     <refsect2info>
      <date>1998-09-08</date>
--- 64,70 ----
      </variablelist>
     </para>
    </refsect2>
! 
    <refsect2 id="R2-SQL-COMMENT-2">
     <refsect2info>
      <date>1998-09-08</date>
***************
*** 99,105 ****
    </title>
    <para>
     <command>COMMENT</command> stores a comment about a database object.
!     Comments can be 
      easily retrieved with <command>psql</command>'s
      <command>\dd</command>, <command>\d+</command>, or <command>\l+</command>
      commands.  Other user interfaces to retrieve comments can be built atop
--- 99,105 ----
    </title>
    <para>
     <command>COMMENT</command> stores a comment about a database object.
!     Comments can be
      easily retrieved with <command>psql</command>'s
      <command>\dd</command>, <command>\d+</command>, or <command>\l+</command>
      commands.  Other user interfaces to retrieve comments can be built atop
***************
*** 141,146 ****
--- 141,147 ----
  
     <programlisting>
  COMMENT ON DATABASE my_database IS 'Development Database';
+ COMMENT ON DOMAIN my_domain IS 'Domains are like abstracted fields';
  COMMENT ON INDEX my_index IS 'Enforces uniqueness on employee id';
  COMMENT ON RULE my_rule IS 'Logs UPDATES of employee records';
  COMMENT ON SEQUENCE my_sequence IS 'Used to generate primary keys';
***************
*** 155,166 ****
     </programlisting>
    </para>
   </refsect1>
!  
   <refsect1 id="R1-SQL-COMMENT-3">
    <title>
     Compatibility
    </title>
!   
    <refsect2 id="R2-SQL-COMMENT-4">
     <refsect2info>
      <date>1998-09-08</date>
--- 156,167 ----
     </programlisting>
    </para>
   </refsect1>
! 
   <refsect1 id="R1-SQL-COMMENT-3">
    <title>
     Compatibility
    </title>
! 
    <refsect2 id="R2-SQL-COMMENT-4">
     <refsect2info>
      <date>1998-09-08</date>
Index: src/backend/catalog/heap.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/catalog/heap.c,v
retrieving revision 1.182
diff -c -r1.182 heap.c
*** src/backend/catalog/heap.c	2002/02/19 20:11:11	1.182
--- src/backend/catalog/heap.c	2002/02/26 02:56:21
***************
*** 700,709 ****
  			   "oidin",			/* receive procedure */
  			   "oidout",		/* send procedure */
  			   NULL,			/* array element type - irrelevant */
  			   NULL,			/* default type value - none */
  			   true,			/* passed by value */
  			   'i',				/* default alignment - same as for OID */
! 			   'p');			/* Not TOASTable */
  }
  
  /* --------------------------------
--- 700,714 ----
  			   "oidin",			/* receive procedure */
  			   "oidout",		/* send procedure */
  			   NULL,			/* array element type - irrelevant */
+ 			   NULL,			/* baseType Name -- typically for domiains */
  			   NULL,			/* default type value - none */
+ 			   NULL,			/* default type binary representation */
  			   true,			/* passed by value */
  			   'i',				/* default alignment - same as for OID */
! 			   'p',				/* Not TOASTable */
! 			   -1,				/* Type mod length */
! 			   0,				/* array dimensions for typBaseType */
! 			   false);			/* Type NOT NULL */
  }
  
  /* --------------------------------
***************
*** 1585,1590 ****
--- 1590,1599 ----
  	HeapTuple	reltup;
  	Form_pg_class relStruct;
  
+ 	/* Probably shouldn't be null by default */
+ 	Node	   *expr = NULL;
+ 
+ 
  	/*
  	 * Get info about existing constraints.
  	 */
***************
*** 1615,1684 ****
  	foreach(listptr, rawColDefaults)
  	{
  		RawColumnDefault *colDef = (RawColumnDefault *) lfirst(listptr);
- 		Node	   *expr;
- 		Oid			type_id;
  
- 		Assert(colDef->raw_default != NULL);
  
! 		/*
! 		 * Transform raw parsetree to executable expression.
! 		 */
! 		expr = transformExpr(pstate, colDef->raw_default, EXPR_COLUMN_FIRST);
  
! 		/*
! 		 * Make sure default expr does not refer to any vars.
! 		 */
! 		if (contain_var_clause(expr))
! 			elog(ERROR, "cannot use column references in DEFAULT clause");
  
  		/*
- 		 * No subplans or aggregates, either...
- 		 */
- 		if (contain_subplans(expr))
- 			elog(ERROR, "cannot use subselects in DEFAULT clause");
- 		if (contain_agg_clause(expr))
- 			elog(ERROR, "cannot use aggregate functions in DEFAULT clause");
- 
- 		/*
- 		 * Check that it will be possible to coerce the expression to the
- 		 * column's type.  We store the expression without coercion,
- 		 * however, to avoid premature coercion in cases like
- 		 *
- 		 * CREATE TABLE tbl (fld datetime DEFAULT 'now'::text);
- 		 *
- 		 * NB: this should match the code in optimizer/prep/preptlist.c that
- 		 * will actually do the coercion, to ensure we don't accept an
- 		 * unusable default expression.
- 		 */
- 		type_id = exprType(expr);
- 		if (type_id != InvalidOid)
- 		{
- 			Form_pg_attribute atp = rel->rd_att->attrs[colDef->attnum - 1];
- 
- 			if (type_id != atp->atttypid)
- 			{
- 				if (CoerceTargetExpr(NULL, expr, type_id,
- 								  atp->atttypid, atp->atttypmod) == NULL)
- 					elog(ERROR, "Column \"%s\" is of type %s"
- 						 " but default expression is of type %s"
- 					"\n\tYou will need to rewrite or cast the expression",
- 						 NameStr(atp->attname),
- 						 format_type_be(atp->atttypid),
- 						 format_type_be(type_id));
- 			}
- 		}
- 
- 		/*
- 		 * Might as well try to reduce any constant expressions.
- 		 */
- 		expr = eval_const_expressions(expr);
- 
- 		/*
- 		 * Must fix opids, in case any operators remain...
- 		 */
- 		fix_opids(expr);
- 
- 		/*
  		 * OK, store it.
  		 */
  		StoreAttrDefault(rel, colDef->attnum, nodeToString(expr), true);
--- 1624,1638 ----
  	foreach(listptr, rawColDefaults)
  	{
  		RawColumnDefault *colDef = (RawColumnDefault *) lfirst(listptr);
  
  
! 		Form_pg_attribute atp = rel->rd_att->attrs[colDef->attnum - 1];
  
! 		expr = cookDefault(pstate, colDef->raw_default
! 						, atp->atttypid, atp->atttypmod
! 						, NameStr(atp->attname));
  
  		/*
  		 * OK, store it.
  		 */
  		StoreAttrDefault(rel, colDef->attnum, nodeToString(expr), true);
***************
*** 1864,1869 ****
--- 1818,1905 ----
  	heap_freetuple(reltup);
  	heap_close(relrel, RowExclusiveLock);
  }
+ 
+ /*
+  * Take a raw default and convert it to a cooked format ready for
+  * storage.
+  *
+  * Parse state, attypid, attypmod and attname are required for
+  * CoerceTargetExpr() and more importantly transformExpr().
+  */
+ Node *
+ cookDefault(ParseState *pstate
+ 			, Node *raw_default
+ 			, Oid atttypid
+ 			, int32 atttypmod
+ 			, char *attname) {
+ 
+ 	Oid			type_id;
+ 	Node		*expr;
+ 
+ 	Assert(raw_default != NULL);
+ 
+ 	/*
+ 	 * Transform raw parsetree to executable expression.
+ 	 */
+ 	expr = transformExpr(pstate, raw_default, EXPR_COLUMN_FIRST);
+ 
+ 	/*
+ 	 * Make sure default expr does not refer to any vars.
+ 	 */
+ 	if (contain_var_clause(expr))
+ 		elog(ERROR, "cannot use column references in DEFAULT clause");
+ 
+ 	/*
+ 	 * No subplans or aggregates, either...
+ 	 */
+ 	if (contain_subplans(expr))
+ 		elog(ERROR, "cannot use subselects in DEFAULT clause");
+ 	if (contain_agg_clause(expr))
+ 		elog(ERROR, "cannot use aggregate functions in DEFAULT clause");
+ 
+ 	/*
+ 	 * Check that it will be possible to coerce the expression to the
+ 	 * column's type.  We store the expression without coercion,
+ 	 * however, to avoid premature coercion in cases like
+ 	 *
+ 	 * CREATE TABLE tbl (fld datetime DEFAULT 'now'::text);
+ 	 *
+ 	 * NB: this should match the code in optimizer/prep/preptlist.c that
+ 	 * will actually do the coercion, to ensure we don't accept an
+ 	 * unusable default expression.
+ 	 */
+ 	type_id = exprType(expr);
+ 	if (type_id != InvalidOid && atttypid != InvalidOid) {
+ 		if (type_id != atttypid) {
+ 
+ 			/* Try coercing to the base type of the domain if available */
+ 			if (CoerceTargetExpr(pstate, expr, type_id,
+ 								 getBaseType(atttypid),
+ 								 atttypmod) == NULL) {
+ 
+ 				elog(ERROR, "Column \"%s\" is of type %s"
+ 					" but default expression is of type %s"
+ 					"\n\tYou will need to rewrite or cast the expression",
+ 					 attname,
+ 					 format_type_be(atttypid),
+ 					 format_type_be(type_id));
+ 			}
+ 		}
+ 	}
+ 
+ 	/*
+ 	 * Might as well try to reduce any constant expressions.
+ 	 */
+ 	expr = eval_const_expressions(expr);
+ 
+ 	/*
+ 	 * Must fix opids, in case any operators remain...
+ 	 */
+ 	fix_opids(expr);
+ 
+ 	return(expr);
+ }
+ 
  
  static void
  RemoveAttrDefault(Relation rel)
Index: src/backend/catalog/pg_type.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/catalog/pg_type.c,v
retrieving revision 1.65
diff -c -r1.65 pg_type.c
*** src/backend/catalog/pg_type.c	2001/10/25 05:49:23	1.65
--- src/backend/catalog/pg_type.c	2002/02/26 02:56:23
***************
*** 178,185 ****
  	values[i++] = ObjectIdGetDatum(InvalidOid); /* 14 */
  	values[i++] = CharGetDatum('i');	/* 15 */
  	values[i++] = CharGetDatum('p');	/* 16 */
  	values[i++] = DirectFunctionCall1(textin,
! 									  CStringGetDatum(typeName));		/* 17 */
  
  	/*
  	 * create a new type tuple with FormHeapTuple
--- 178,190 ----
  	values[i++] = ObjectIdGetDatum(InvalidOid); /* 14 */
  	values[i++] = CharGetDatum('i');	/* 15 */
  	values[i++] = CharGetDatum('p');	/* 16 */
+ 		values[i++] = BoolGetDatum(false);	/* 17 */
+ 			values[i++] = Int32GetDatum(-1);	/* 18 */
  	values[i++] = DirectFunctionCall1(textin,
! 									  CStringGetDatum(typeName));		/* 19 */
! 	values[i++] = DirectFunctionCall1(textin,
! 									  CStringGetDatum(typeName));		/* 20 */
! 
  
  	/*
  	 * create a new type tuple with FormHeapTuple
***************
*** 264,270 ****
  Oid
  TypeCreate(char *typeName,
  		   Oid assignedTypeOid,
! 		   Oid relationOid,		/* only for 'c'atalog typeTypes */
  		   int16 internalSize,
  		   int16 externalSize,
  		   char typeType,
--- 269,275 ----
  Oid
  TypeCreate(char *typeName,
  		   Oid assignedTypeOid,
! 		   Oid relationOid,			/* only for 'c'atalog typeTypes */
  		   int16 internalSize,
  		   int16 externalSize,
  		   char typeType,
***************
*** 274,283 ****
  		   char *receiveProcedure,
  		   char *sendProcedure,
  		   char *elementTypeName,
! 		   char *defaultTypeValue,		/* internal rep */
  		   bool passedByValue,
  		   char alignment,
! 		   char storage)
  {
  	int			i,
  				j;
--- 279,293 ----
  		   char *receiveProcedure,
  		   char *sendProcedure,
  		   char *elementTypeName,
! 		   char *baseTypeName,
! 		   char *defaultTypeValue,	/* human readable rep */
! 		   char *defaultTypeBin,	/* cooked rep */
  		   bool passedByValue,
  		   char alignment,
! 		   char storage,
! 		   int32 typeMod,
! 		   int32 typNDims,			/* Array dimensions for baseTypeName */
! 		   bool typeNotNull)		/* binary default representation (cooked) */
  {
  	int			i,
  				j;
***************
*** 285,290 ****
--- 295,301 ----
  	HeapScanDesc pg_type_scan;
  	Oid			typeObjectId;
  	Oid			elementObjectId = InvalidOid;
+ 	Oid			baseObjectId = InvalidOid;
  	HeapTuple	tup;
  	char		nulls[Natts_pg_type];
  	char		replaces[Natts_pg_type];
***************
*** 318,323 ****
--- 329,345 ----
  	}
  
  	/*
+ 	 * if this type has an associated baseType, then we check that it
+ 	 * is defined.
+ 	 */
+ 	if (baseTypeName)
+ 	{
+ 		baseObjectId = TypeGet(baseTypeName, &defined);
+ 		if (!defined)
+ 			elog(ERROR, "type %s does not exist", baseTypeName);
+ 	}
+ 
+ 	/*
  	 * validate size specifications: either positive (fixed-length) or -1
  	 * (variable-length).
  	 */
***************
*** 388,394 ****
  			 * signature is 0,OIDOID,INT4OID.  The output procedures may
  			 * take 2 args (data value, element OID).
  			 */
! 			if (OidIsValid(elementObjectId))
  			{
  				int			nargs;
  
--- 410,416 ----
  			 * signature is 0,OIDOID,INT4OID.  The output procedures may
  			 * take 2 args (data value, element OID).
  			 */
! 			if (OidIsValid(elementObjectId) || OidIsValid(baseObjectId))
  			{
  				int			nargs;
  
***************
*** 411,416 ****
--- 433,439 ----
  										 PointerGetDatum(argList),
  										 0);
  			}
+ 
  			if (!OidIsValid(procOid))
  				func_error("TypeCreate", procname, 1, argList, NULL);
  		}
***************
*** 429,434 ****
--- 452,485 ----
  	values[i++] = CharGetDatum(storage);		/* 16 */
  
  	/*
+ 	 * set the typenotnull value
+ 	 */
+ 	values[i++] = BoolGetDatum(typeNotNull);	/* 17 */
+ 
+ 	/*
+ 	 * set the typemod value
+ 	 */
+ 	values[i++] = Int32GetDatum(typeMod);			/* 18 */
+ 
+ 	values[i++] = ObjectIdGetDatum(baseObjectId);	/* 19 */
+ 
+ 	/*
+ 	 * Dimension number for an array base type
+ 	 */
+ 	values[i++] = Int32GetDatum(typNDims);			/* 20 */
+ 
+ 	/*
+ 	 * initialize the default binary value for this type.  Check for
+ 	 * nulls of course.
+ 	 */
+ 	if (defaultTypeBin)
+ 		values[i] = DirectFunctionCall1(textin,
+ 									  CStringGetDatum(defaultTypeBin));
+ 	else
+ 		nulls[i] = 'n';
+ 	i++;										/* 21 */
+ 
+ 	/*
  	 * initialize the default value for this type.
  	 */
  	if (defaultTypeValue)
***************
*** 436,442 ****
  									  CStringGetDatum(defaultTypeValue));
  	else
  		nulls[i] = 'n';
! 	i++;						/* 17 */
  
  	/*
  	 * open pg_type and begin a scan for the type name.
--- 487,493 ----
  									  CStringGetDatum(defaultTypeValue));
  	else
  		nulls[i] = 'n';
! 	i++;						/* 22 */
  
  	/*
  	 * open pg_type and begin a scan for the type name.
Index: src/backend/commands/creatinh.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/commands/creatinh.c,v
retrieving revision 1.81
diff -c -r1.81 creatinh.c
*** src/backend/commands/creatinh.c	2001/10/25 05:49:24	1.81
--- src/backend/commands/creatinh.c	2002/02/26 02:56:25
***************
*** 39,46 ****
  static void StoreCatalogInheritance(Oid relationId, List *supers);
  static int	findAttrByName(const char *attributeName, List *schema);
  static void setRelhassubclassInRelation(Oid relationId, bool relhassubclass);
  
- 
  /* ----------------------------------------------------------------
   *		DefineRelation
   *				Creates a new relation.
--- 39,46 ----
  static void StoreCatalogInheritance(Oid relationId, List *supers);
  static int	findAttrByName(const char *attributeName, List *schema);
  static void setRelhassubclassInRelation(Oid relationId, bool relhassubclass);
+ static List *MergeDomainAttributes(List *schema);
  
  /* ----------------------------------------------------------------
   *		DefineRelation
   *				Creates a new relation.
***************
*** 70,75 ****
--- 70,82 ----
  	StrNCpy(relname, stmt->relname, NAMEDATALEN);
  
  	/*
+ 	 * Merge domain attributes into the known columns before inheritance
+ 	 * applies it's changes otherwise we risk adding double constraints
+ 	 * to a domain thats inherited.
+ 	 */
+ 	schema = MergeDomainAttributes(schema);
+ 
+ 	/*
  	 * Look up inheritance ancestors and generate relation schema,
  	 * including inherited attributes.
  	 */
***************
*** 235,240 ****
--- 242,329 ----
  {
  	AssertArg(name);
  	heap_truncate(name);
+ }
+ 
+ 
+ /*
+  * MergeDomainAttributes
+  *      Returns a new schema with the constraints, types, and other
+  *      attributes of the domain resolved.
+  *
+  * Defaults are processed at execution time by taking the default of
+  * the type (domain) if it is null.  This does not need to be merged
+  * here.
+  */
+ static List *
+ MergeDomainAttributes(List *schema)
+ {
+ 	List	   *entry;
+ 
+ 	/*
+ 	 * Loop through the table elements supplied. These should
+ 	 * never include inherited domains else they'll be
+ 	 * double (or more) processed.
+ 	 */
+ 	foreach(entry, schema)
+ 	{
+ 		ColumnDef  *coldef = lfirst(entry);
+ 		HeapTuple  tuple;
+ 		Form_pg_type typeTup;
+ 
+ 
+ 		tuple = SearchSysCache(TYPENAME,
+ 							   CStringGetDatum(coldef->typename->name),
+ 							   0,0,0);
+ 
+ 		if (!HeapTupleIsValid(tuple))
+ 			elog(ERROR, "MergeDomainAttributes: Type %s does not exist",
+ 				 coldef->typename->name);
+ 
+ 		typeTup = (Form_pg_type) GETSTRUCT(tuple);
+ 		if (typeTup->typtype == 'd') {
+ 			/*
+ 			 * This is a domain, lets force the properties of the domain on to
+ 			 * the new column.
+ 			 */
+ 
+ 			/* Enforce the typmod value */
+ 			coldef->typename->typmod = typeTup->typmod;
+ 
+ 			/* Enforce type NOT NULL || column definition NOT NULL -> NOT NULL */
+ 			coldef->is_not_null |= typeTup->typnotnull;
+ 
+ 			/* Enforce the element type in the event the domain is an array
+ 			 *
+ 			 * BUG: How do we fill out arrayBounds and attrname from typelem and typNDimms?
+ 			 */
+ 
+ 		}
+ 		ReleaseSysCache(tuple);
+ 
+ //typedef struct TypeName
+ //{
+ 	//NodeTag		type;
+ 	//char	   *name;			/* name of the type */
+ 	//bool		timezone;		/* timezone specified? */
+ 	//bool		setof;			/* is a set? */
+ 	//int32		typmod;			/* type modifier */
+ 	//List	   *arrayBounds;	/* array bounds */
+ 	//char	   *attrname;		/* field name when using %TYPE */
+ //} TypeName;
+ 
+ // ColumnDef
+ //		NodeTag		type;
+ //		char	   *colname;		/* name of column */
+ //		TypeName   *typename;		/* type of column */
+ //		bool		is_not_null;	/* NOT NULL constraint specified? */
+ //		Node	   *raw_default;	/* default value (untransformed parse
+ //								 * tree) */
+ //		char	   *cooked_default; /* nodeToString representation */
+ //		List	   *constraints;	/* other constraints on column */
+ 
+ 	}
+ 
+ 	return schema;
  }
  
  /*----------
